/**
 * IMPORTANT !
 * Décommenter temporairement la ligne suivante (import { } from "./mock_jasmine")
 * Pour exécuter ce code dans le débugger.
 * Faire de même avec le fichier test_func.ts
 */
// import { describe, expect, it, xdescribe, xit } from "../mock_jasmine";

import { Dever, DeverParams } from "../../src/structure/dever";
import { CreateStructure } from "../../src/structure/factory_structure";
import { LoiDebit, StructureType } from "../../src/structure/structure_props";
import { Result } from "../../src/util/result";

const dever: Dever = new Dever(
    new DeverParams(
        0,     // rQ Débit total (m3/s)
        102,   // rZ1 Cote de l'eau amont (m)
        2,     // rBR Largeur du cours d'eau amont (m)
        100    // rZR Cote du lit du cours d'eau amont (m)
    ),
    false // debug
);

dever.addStructure(CreateStructure(StructureType.SeuilTriangulaireTrunc, LoiDebit.TriangularTruncWeirFree, false));

describe("Class Dever: ", () => {
    describe("Calc(Q) Seuil Triangulaire Trunc", () => {
        it("vCalc should return 5.407", () => {
            expect(dever.Calc("Q").vCalc).toBeCloseTo(5.407, 3);
        });
        it("extraResults.V should return 1.352", () => {
            expect(dever.Calc("Q").extraResults.V).toBeCloseTo(1.352, 3);
        });
        it("extraResults.Ec should return 0.093", () => {
            expect(dever.Calc("Q").extraResults.Ec).toBeCloseTo(0.093, 3);
        });
        it("extraResults.Cv should return 1.116", () => {
            expect(dever.Calc("Q").extraResults.Cv).toBeCloseTo(1.116, 3);
        });
        it("extraResults.CvQT should return 6.036", () => {
            expect(dever.Calc("Q").extraResults.CvQT).toBeCloseTo(6.036, 3);
        });
    });
});
