/**
 * IMPORTANT !
 * Décommenter temporairement la ligne suivante (import { } from "./mock_jasmine")
 * Pour exécuter ce code dans le débugger.
 */
// import { describe, expect, it, xdescribe } from "../mock_jasmine";

import { Structure } from "../../src/structure/structure";
import { StructureFlowMode, StructureFlowRegime } from "../../src/structure/structure";
import { Describer } from "../../src/util/describer";
import { Result } from "../../src/util/result";
import { precDigits } from "../test_config";

export function itCalcQ(
    struct: Structure, Z1: number, W: number, Q: number,
    mode?: StructureFlowMode, regime?: StructureFlowRegime, precDigits2?: number) {

    struct.debug("itCalQ " + Describer.getName(struct) + " Z1=" + Z1 + " W=" + W + " Q=" + Q);

    struct.prms.Z1.v = Z1;
    struct.prms.W.v = W;
    const res: Result = struct.Calc("Q");
    struct.debug("struct.Calc(Q)=" + res.vCalc);

    it("Q(Z1=" + Z1 + ",W=" + W + ") should be " + Q, () => {
        if (precDigits2 === undefined) { precDigits2 = precDigits; }
        struct.debug("struct.Calc(Q)=" + res.vCalc);
        expect(res.vCalc).toBeCloseTo(Q, precDigits2);
    });
    if (mode !== undefined) {
        it("Q(Z1=" + Z1 + ",W=" + W + ") Mode should be " + mode, () => {
            expect(res.extraResults.Mode).toBe(mode);
        });
    }
    if (regime !== undefined) {
        it("Q(Z1=" + Z1 + ",W=" + W + ") Regime should be " + regime, () => {
            expect(res.extraResults.Regime).toBe(regime);
        });
    }
}
