/**
 * IMPORTANT !
 * Décommenter temporairement la ligne suivante (import { } from "./mock_jasmine")
 * Pour exécuter ce code dans le débugger.
 * Faire de même avec le fichier rectangular_structure.ts
 */
// import { describe, expect, it, xdescribe } from "../mock_jasmine";

import { StructureFlowMode, StructureFlowRegime } from "../../src/structure/structure";
import { StructureTriangularWeirFree } from "../../src/structure/structure_triangular_weir_free";
import { TriangularStructureParams } from "../../src/structure/structure_triangular_weir_free_params";
import { itCalcQ } from "./functions";

const structPrm: TriangularStructureParams = new TriangularStructureParams(0, 100.1, 100.1, 45, 1.36);
const structTest: StructureTriangularWeirFree = new StructureTriangularWeirFree(structPrm, false);

describe("Class StructureTriangularWeirFree: ", () => {
    describe("Calcul Q a surface libre avec h1 croissant: ", () => {
        const h1: number[] = [100.1, 100.2, 100.3, 100.4, 100.5, 100.6, 100.7, 100.8, 100.9, 101, 102];
        const Q: number[] = [0., 0.004, 0.024, 0.067, 0.138, 0.240, 0.379, 0.558, 0.778, 1.045, 6.767];
        const mode: StructureFlowMode = StructureFlowMode.WEIR;
        const regime: StructureFlowRegime = StructureFlowRegime.FREE;
        itCalcQ(structTest, h1[0], Infinity, Q[0], StructureFlowMode.NULL, StructureFlowRegime.NULL);
        for (let i = 1; i < Q.length; i++) {
            itCalcQ(structTest, h1[i], Infinity, Q[i], mode, regime);
        }
    });
});
